
typedef	void	(cdecl *UTXT_FN)( WORD x, WORD y, WORD *clip_rect, LONG id, LONG pt, LONG ratio, BYTE *string );

typedef struct _fnts_item
{
	struct	_fnts_item	*next;										/* Zeiger auf den nchsten Font oder 0L (Ende der Liste) */
	UTXT_FN	display;														/* Zeiger auf die Anzeige-Funktion fr applikationseigene Fonts */
	LONG		id;															/* ID des Fonts, >= 65536 fr applikationseigene Fonts */
	WORD		index;														/* Index des Fonts (falls VDI-Font) */
	BYTE		mono;															/* Flag fr quidistante Fonts */
	BYTE		outline;														/* Flag fr Vektorfont */
	WORD		npts;															/* Anzahl der vordefinierten Punkthhen */
	BYTE		*full_name;													/* Zeiger auf den vollstndigen Namen */
	BYTE		*family_name;												/* Zeiger auf den Familiennamen */
	BYTE		*style_name;												/* Zeiger auf den Stilnamen */
	BYTE		*pts;															/* Zeiger auf Feld mit Punkthhen */
	LONG		reserved[4];												/* reserviert, mssen 0 sein */
} FNTS_ITEM;

/* Definitionen fr <font_flags> bei fnts_create() */

#define	FNTS_BTMP	1													/* Bitmapfonts anzeigen */
#define	FNTS_OUTL	2													/* Vektorfonts anzeigen */
#define	FNTS_MONO	4													/* quidistante Fonts anzeigen */
#define	FNTS_PROP	8													/* proportionale Fonts anzeigen */

/* Definitionen fr <dialog_flags> bei fnts_create() */
#define	FNTS_3D		1													/* 3D-Design benutzen */

/* Definitionen fr <button_flags> bei fnts_open() */
#define	FNTS_SNAME		0x01											/* Checkbox fr die Namen selektieren */
#define	FNTS_SSTYLE		0x02											/* Checkbox fr die Stile selektieren */
#define	FNTS_SSIZE		0x04											/* Checkbox fr die Hhe selektieren */
#define	FNTS_SRATIO		0x08											/* Checkbox fr das Verhltnis Breite/Hhe selektieren */

#define	FNTS_CHNAME		0x0100										/* Checkbox fr die Namen anzeigen */
#define	FNTS_CHSTYLE	0x0200										/* Checkbox fr die Stile anzeigen */
#define	FNTS_CHSIZE		0x0400										/* Checkbox fr die Hhe anzeigen */
#define	FNTS_CHRATIO	0x0800										/* Checkbox fr das Verhltnis Breite/Hhe anzeigen */
#define	FNTS_RATIO		0x1000										/* Verhltnis Breite/Hhe einstellbar */
#define	FNTS_BSET		0x2000										/* Button "setzen" anwhlbar */
#define	FNTS_BMARK		0x4000										/* Button "markieren" anwhlbar */

/* Definitionen fr <button> bei fnts_evnt() */

#define	FNTS_CANCEL	1													/* "Abbruch" wurde angewhlt */
#define	FNTS_OK		2													/* "OK" wurde gedrckt */
#define	FNTS_SET		3													/* "setzen" wurde angewhlt */
#define	FNTS_MARK	4													/* "markieren" wurde bettigt */
#define	FNTS_OPT		5													/* der applikationseigene Button wurde ausgewhlt */

extern void	*fnts_create( WORD vdi_handle, WORD no_fonts, WORD font_flags, WORD dialog_flags, BYTE *sample, BYTE *opt_button );
extern WORD	fnts_delete( void *fnt_dialog, WORD vdi_handle );
extern WORD	fnts_open( void *fnt_dialog, WORD button_flags, WORD x, WORD y, LONG id, LONG pt, LONG ratio );
extern WORD	fnts_close( void *fnt_dialog );

extern WORD	fnts_get_no_styles( void *fnt_dialog, LONG id );
extern LONG	fnts_get_style( void *fnt_dialog, LONG id, WORD index );
extern WORD	fnts_get_name( void *fnt_dialog, LONG id, BYTE *full_name, BYTE *family_name, BYTE *style_name );
extern WORD	fnts_get_info( void *fnt_dialog, LONG id, WORD *mono, WORD *outline );

extern WORD	fnts_add( void *fnt_dialog, FNTS_ITEM *user_fonts );
extern void	fnts_remove( void *fnt_dialog );

extern WORD	fnts_evnt( void *fnt_dialog, EVNT *events, WORD *button, WORD *check_boxes, LONG *id, LONG *pt, LONG *ratio );
extern WORD	fnts_do( void *fnt_dialog, WORD button_flags, LONG id_in, LONG pt_in, LONG ratio_in, 
							WORD *check_boxes, LONG *id, LONG *pt, LONG *ratio );
