/*
*
* Binding fr die Benutzung einer "shared library"
*
* Andreas Kromke
* 22.10.97
*
*/

#include <mgx_dos.h>

/*****************************************************************
*
* ffnet eine "shared lib".
*
* Eingabe:
*	name			Name der Bibliothek inkl. Extension.
*	path			Suchpfad mit '\', optional
*	min_ver		Minimale bentigte Versionsnummer
* Rckgabe:
*	sl			Bibliotheks-Deskriptor
*	fn			Funktion zum Aufruf einer Bibliotheksfunktion
*	<ret>		tatschliche Versionsnummer oder Fehlercode
*
*****************************************************************/

LONG Slbopen( char *name, char *path, LONG min_ver,
				SHARED_LIB *sl, SLB_EXEC *fn,
				LONG param )
{
	return(gemdos(0x16, name, path, min_ver, sl, fn, param));
}


/*****************************************************************
*
* Schliet eine "shared lib".
*
* Rckgabe:
*	<ret>		EACCDN, falls Lib nicht geffnet
*
*****************************************************************/

extern LONG Slbclose( SHARED_LIB *sl )

{
	return(gemdos(0x17, sl));
}
