'MIDI Square
'HiSoft BASIC 5/18/93
'Copyright 1993 David Snow

defint a-z

REM $include MIDISQAR.BH 
library "gemdos","gemvdi","gemaes"
rem $option y+,v+,L40

CONST steps_per_quarternote=96,ob_spec=12,ob_state=10,selected=1

gosub initialize

do
	button=FNform_do(midisqar_pointer&,0)
	select case button
	=bpm_up
		if tempo<240 then
			new_tempo_flag=1
			incr tempo
			gosub show_tempo
		end if
	=bpm_down
		if tempo>20 then
			new_tempo_flag=1
			decr tempo
			gosub show_tempo
		end if
	=channel_up
		for index=0 to 3
			incr m_channel(index)
			if m_channel(index)>15 then
				m_channel(index)=0
			end if
		next
		gosub show_channel
	=channel_down
		for index=0 to 3
			decr m_channel(index)
			if m_channel(index)<0 then
				m_channel(index)=15
			end if
		next
		gosub show_channel
	=transpose_up
		if global_transposition<9 then
			incr global_transposition
		end if
		gosub show_transposition
	=transpose_down
		if global_transposition>-9 then
			decr global_transposition
		end if
		gosub show_transposition
	=horizontal_up
		if x_offset<7 then
			incr x_offset
		end if
		gosub show_horizontal
	=horizontal_down
		if x_offset>-7 then
			decr x_offset
		end if
		gosub show_horizontal
	=vertical_up
		if y_offset<7 then
			incr y_offset
		end if
		gosub show_vertical
	=vertical_down
		if y_offset>-7 then
			decr y_offset
		end if
		gosub show_vertical
	=unit_up
		if units_index<5 then
			incr units_index
		end if
		gosub show_units
	=unit_down
		if units_index>0 then
			decr units_index
		end if
		gosub show_units
	=start_button
		if midifile_flag=0 then	
			beep
			midifile_flag=1
			smf_buffer&=varptr(smf_buffer(0))
			pokel smf_buffer&+18,0				'dummy track length
			smf_index&=22
			gosub set_tempo
		end if
	=stop_button
		if midifile_flag then
			beep
			midifile_flag=0
			gosub save_midifile
		end if
	=midi_square
		gosub select_mode
		gosub select_velocity
		gosub set_unit_duration
		if midifile_flag and new_tempo_flag then
			new_tempo_flag=0
			gosub set_tempo
		end if
		gosub play_square
	=c_natural%
		source_scale(0)=1
		gosub fill_gamut
	=c_flat%
		source_scale(0)=0
		gosub fill_gamut
	=c_sharp%
		source_scale(0)=2
		gosub fill_gamut
	=d_natural%
		source_scale(1)=3
		gosub fill_gamut
	=d_flat%
		source_scale(1)=2
		gosub fill_gamut
	=d_sharp%
		source_scale(1)=4
		gosub fill_gamut
	=e_natural%
		source_scale(2)=5
		gosub fill_gamut
	=e_flat%
		source_scale(2)=4
		gosub fill_gamut
	=e_sharp%
		source_scale(2)=6
		gosub fill_gamut
	=f_natural%
		source_scale(3)=6
		gosub fill_gamut
	=f_flat%
		source_scale(3)=5
		gosub fill_gamut
	=f_sharp%
		source_scale(3)=7
		gosub fill_gamut
	=g_natural%
		source_scale(4)=8
		gosub fill_gamut
	=g_flat%
		source_scale(4)=7
		gosub fill_gamut
	=g_sharp%
		source_scale(4)=9
		gosub fill_gamut
	=a_natural%
		source_scale(5)=10
		gosub fill_gamut
	=a_flat%
		source_scale(5)=9
		gosub fill_gamut
	=a_sharp%
		source_scale(5)=11
		gosub fill_gamut
	=b_natural%
		source_scale(6)=12
		gosub fill_gamut
	=b_flat%
		source_scale(6)=11
		gosub fill_gamut
	=b_sharp%
		source_scale(6)=13
		gosub fill_gamut
	=exit_button
		alert$="[3][Exit MIDI Square?][Yes|No]"
		if FNform_alert(1,alert$)=1 then
			system
		else
			junk=FNobjc_change(midisqar_pointer&,exit_button,x,y,w,h,0,1)
		end if
	end select
loop

play_square:
	graf_mouse 6,0
	old_x_index=-1
	old_y_index=-1

	JUNK=FNWIND_UPDATE(3)
	next_unit!=timer
	delta_time&=0-steps_per_unit
	do
		if timer>=next_unit! then
			next_unit!=timer+unit_duration!
			delta_time&=delta_time&+steps_per_unit

			graf_mkstate mouse_x,mouse_y,mouse_button,0
			if mouse_button=0 then
				if note_on_flag then
					note_on_flag=0
					note_off m_channel(0),scale_gamut(old_x_index)+global_transposition
					note_off m_channel(1),scale_gamut(old_x_index+x_offset)+global_transposition
					note_off m_channel(2),scale_gamut(old_y_index)+global_transposition
					note_off m_channel(3),scale_gamut(old_y_index+y_offset)+global_transposition
					old_x_index=-1
					old_y_index=-1
					key_check
				else
					key_check
				end if
				if mouse_x<square_left or mouse_x>=square_right or mouse_y<square_top or mouse_y>=square_bottom then
					JUNK=FNWIND_UPDATE(2)
					graf_mouse 0,0
					exit loop
				end if
			elseif mouse_x>=square_left and mouse_x<square_right and mouse_y>=square_top and mouse_y<square_bottom then
				x_index=(mouse_x-square_left)\8+7
				y_index=(mouse_y-square_top)\8+7

				if x_index<>old_x_index or y_index<>old_y_index then
					if mouse_button and 2 then
						x_velocity=(x_index-7)*3
						y_velocity=(y_index-7)*3
						if inverse_velocity then
							x_velocity=93-x_velocity
							y_velocity=93-y_velocity
						end if
						x_velocity=x_velocity+32
						y_velocity=y_velocity+32
					end if
					if mouse_button and 1 then
						if note_on_flag then
							note_off m_channel(0),scale_gamut(old_x_index)+global_transposition
							note_off m_channel(1),scale_gamut(old_x_index+x_offset)+global_transposition
							note_off m_channel(2),scale_gamut(old_y_index)+global_transposition
							note_off m_channel(3),scale_gamut(old_y_index+y_offset)+global_transposition
							key_check
						end if
						note_on m_channel(0),scale_gamut(x_index)+global_transposition,x_velocity
						note_on m_channel(1),scale_gamut(x_index+x_offset)+global_transposition,x_velocity
						note_on m_channel(2),scale_gamut(y_index)+global_transposition,y_velocity
						note_on m_channel(3),scale_gamut(y_index+y_offset)+global_transposition,y_velocity
						note_on_flag=1
						old_x_index=x_index
						old_y_index=y_index
					end if
				end if
			end if
		end if
	loop
	return

'*******
SUB key_check
SHARED global_transposition
STATIC keypress
	if inp(-2)<>0 then
		keypress=inp(2)
		select case keypress
		="1"%
			global_transposition=1
		="2"%
			global_transposition=2
		="3"%
			global_transposition=3
		="4"%
			global_transposition=4
		="5"%
			global_transposition=5
		="6"%
			global_transposition=6
		="7"%
			global_transposition=7
		="8"%
			global_transposition=8
		="9"%
			global_transposition=9
		="0"%
			global_transposition=0
		="!"%
			global_transposition=-1
		="@"%
			global_transposition=-2
		="#"%
			global_transposition=-3
		="$"%
			global_transposition=-4
		="%"%
			global_transposition=-5
		="^"%
			global_transposition=-6
		="&"%
			global_transposition=-7
		="*"%
			global_transposition=-8
		="("%
			global_transposition=-9
		=")"%
			global_transposition=0
		end select
		gosub show_transposition
	end if
END SUB

DEF FNput_text%(root&,object%,t$)
	STATIC te_ptext&,index
	te_ptext&=peekl(peekl(root&+24*object%+ob_spec))
	for index=1 to len(t$)
		pokeb te_ptext&,asc(mid$(t$,index,1))
		incr te_ptext&
	next
END DEF

DEF FNobject_state&(root&,object%)=root&+24*object%+ob_state

SUB note_off(global_channel,pitch)
SHARED midifile_flag,smf_buffer&,smf_index&
	out 3,128+global_channel
	out 3,pitch
	out 3,64
	'*********
	IF MIDIFILE_FLAG THEN
		gosub delta_conversion
		pokeb smf_buffer&+smf_index&,128+global_channel
		incr smf_index&
		pokeb smf_buffer&+smf_index&,pitch
		incr smf_index&
		pokeb smf_buffer&+smf_index&,64
		incr smf_index&
	END IF
	'*********
END SUB

SUB note_on(global_channel,pitch,velocity)
SHARED midifile_flag,smf_buffer&,smf_index&
	out 3,144+global_channel
	out 3,pitch
	out 3,velocity
	'*********
	IF MIDIFILE_FLAG THEN
		gosub delta_conversion
		pokeb smf_buffer&+smf_index&,144+global_channel
		incr smf_index&
		pokeb smf_buffer&+smf_index&,pitch
		incr smf_index&
		pokeb smf_buffer&+smf_index&,velocity
		incr smf_index&
	END IF
	'*********
END SUB

SUB program_change(global_channel,number)
SHARED midifile_flag,smf_buffer&,smf_index&
	out 3,192+global_channel
	out 3,number
	'*********
	IF MIDIFILE_FLAG THEN
		gosub delta_conversion
		pokeb smf_buffer&+smf_index&,192+global_channel
		incr smf_index&
		pokeb smf_buffer&+smf_index&,number
		incr smf_index&
	END IF
	'*********
END SUB

fill_gamut:
	for index=0 to 6
		scale_gamut(index)=source_scale(index)+23
		scale_gamut(index+7)=source_scale(index)+12+23
		scale_gamut(index+14)=source_scale(index)+24+23
		scale_gamut(index+21)=source_scale(index)+36+23
		scale_gamut(index+28)=source_scale(index)+48+23
		scale_gamut(index+35)=source_scale(index)+60+23
		scale_gamut(index+42)=source_scale(index)+72+23
	next
	return

initialize:
	graf_mouse 256,0
	if FNrsrc_load("M:\MIDISQAR.RSC")=0 then
		graf_mouse 257,0
		alert$="[1][MIDISQAR.RSC missing.][Abort]"
		junk=FNform_alert(1,alert$)
		system
	end if

	restore source_scale_data
	dim source_scale(7)
	for index=0 to 6
		read source_scale(index)
	next
	restore units_data
	dim units_per_beat(5)
		for index=0 to 5
		read units_per_beat(index)
	next

	dim scale_gamut(48)
	gosub fill_gamut

	drive_no=FNdgetdrv%
	getdir$=space$(128)
	getdir&=sadd(getdir$)
	dgetpath getdir&,0
	index=0: while peekb(getdir&+index)<>32: index=index+1: wend
	path$=chr$(drive_no+65)+":"+left$(getdir$,index-1)
	midifile_path$=path$+"\*.MID"

	buffer_size&=fre(0)-&h20000
	dim smf_buffer(buffer_size&\2)
	smf_buffer&=varptr(smf_buffer(0))

	'SET UP SMF HEADER CHUNK
	pokeb smf_buffer&,asc("M")
	pokeb smf_buffer&+1,asc("T")
	pokeb smf_buffer&+2,asc("h")
	pokeb smf_buffer&+3,asc("d")
	pokel smf_buffer&+4,6		'length of header
	pokew smf_buffer&+8,0		'SMF format 0
	pokew smf_buffer&+10,1		'1 track
	pokew smf_buffer&+12,steps_per_quarternote

	'SET UP TRACK CHUNK
	pokeb smf_buffer&+14,asc("M")
	pokeb smf_buffer&+15,asc("T")
	pokeb smf_buffer&+16,asc("r")
	pokeb smf_buffer&+17,asc("k")

	midifile_flag=0
	m_channel(0)=15
	m_channel(1)=15
	m_channel(2)=15
	m_channel(3)=15
	tempo=120
	units_index=3
	x_offset=4
	y_offset=-4
	x_velocity=96
	y_velocity=96

	junk=FNrsrc_gaddr(0,main_screen%,midisqar_pointer&)
	form_center midisqar_pointer&,x,y,w,h
	form_dial 0,0,0,0,0,x,y,w,h
	junk=FNobjc_draw(midisqar_pointer&,0,7,x,y,w,h)
	junk=FNobjc_offset(midisqar_pointer&,midi_square%,square_left,square_top)

	square_bottom=square_top+256
	square_right=square_left+256

	for horizontal=0 to 32
		pts(0)=square_left
		pts(1)=square_top+(horizontal*8)
		pts(2)=square_right
		pts(3)=pts(1)
		v_pline 2,pts()
	next

	for vertical=0 to 32
		pts(0)=square_left+(vertical*8)
		pts(1)=square_top
		pts(2)=pts(0)
		pts(3)=square_bottom
		v_pline 2,pts()
	next

	gosub show_tempo
	gosub show_channel
	gosub show_transposition
	gosub show_horizontal
	gosub show_vertical
	gosub show_units

	graf_mouse 257,0
	beep
	return

set_unit_duration:
	steps_per_unit=STEPS_PER_QUARTERNOTE/units_per_beat(units_index)
	step_duration!=60/(TEMPO*steps_per_quarternote)
	unit_duration!=steps_per_unit*step_duration!
	return

set_tempo:
	smf_tempo&=(60/tempo)*1000000
	smf_tempo_ptr&=varptr(smf_tempo&)

	pokeb smf_buffer&+smf_index&,&h00	'delta time
	incr smf_index&
	pokeb smf_buffer&+smf_index&,&hff	'meta event
	incr smf_index&
	pokeb smf_buffer&+smf_index&,&h51
	incr smf_index&
	pokeb smf_buffer&+smf_index&,&h03
	incr smf_index&
	pokeb smf_buffer&+smf_index&,peekb(smf_tempo_ptr&+1)
	incr smf_index&
	pokeb smf_buffer&+smf_index&,peekb(smf_tempo_ptr&+2)
	incr smf_index&
	pokeb smf_buffer&+smf_index&,peekb(smf_tempo_ptr&+3)
	incr smf_index&
	return

'DELTA TIME VARIABLE-LENGTH QUANTITY CONVERSION
delta_conversion:
	vlq_buffer&=0
	vlq_pointer&=varptr(vlq_buffer&)
	pokeb vlq_pointer&+3,delta_time& and &h7f
	pointer_offset&=2
	delta_time&=delta_time&\&h80
	while delta_time&<>0
		pokeb vlq_pointer&+pointer_offset&,delta_time& or &h80
		decr pointer_offset&
		delta_time&=delta_time&\&h80
	wend
	incr pointer_offset&
	while pointer_offset&<4
		pokeb smf_buffer&+smf_index&,peekb(vlq_pointer&+pointer_offset&)
		incr smf_index&
		incr pointer_offset&
	wend
	return

save_midifile:
	beep

	'APPEND END-OF-TRACK META-EVENT
	delta_time&=0
	gosub delta_conversion

	pokeb smf_buffer&+smf_index&,&hff	'meta-event
	incr smf_index&
	pokeb smf_buffer&+smf_index&,&h2f
	incr smf_index&
	pokeb smf_buffer&+smf_index&,&h00

	pokel smf_buffer&+18,smf_index&-22	'update sequence length

	save_midi:
	file_name$=""
	fsel_input midifile_path$,file_name$,ok
	if ok then
		if file_name$="" then
			alert$="[3][Are you sure you want|to discard MIDI file?][Yes|No]"
			if FNform_alert(1,alert$)=2 then
				goto save_midi
			end if
		else
			graf_mouse 2,0
			index=len(midifile_path$)
			while index>0 and mid$(midifile_path$,index,1)<>"\"
				decr index
			wend
			exit_file$=left$(midifile_path$,index)+file_name$
			BSAVE exit_file$,SMF_BUFFER&,SMF_INDEX&
			graf_mouse 0,0
		end if
	else
		alert$="[3][Are you sure you want|to discard MIDI file?][Yes|No]"
		if FNform_alert(1,alert$)=2 then
			goto save_midi
		end if
	end if
	RETURN

show_channel:
	text$=right$(str$(m_channel(0)+1),2)+chr$(0)
	junk=FNput_text%(midisqar_pointer&,midi_channel,text$)
	junk=FNobjc_draw(midisqar_pointer&,midi_channel,0,x,y,w,h)
	return

show_tempo:
	text$=right$(str$(tempo),3)+chr$(0)
	junk=FNput_text%(midisqar_pointer&,beats_per_minute,text$)
	junk=FNobjc_draw(midisqar_pointer&,beats_per_minute,0,x,y,w,h)
	return

show_units:
	text$=right$(str$(units_per_beat(units_index)),1)+chr$(0)
	junk=FNput_text%(midisqar_pointer&,beat_division,text$)
	junk=FNobjc_draw(midisqar_pointer&,beat_division,0,x,y,w,h)
	return

show_transposition:
	text$=right$(str$(global_transposition),2)+chr$(0)
	if global_transposition>0 then
		mid$(text$,1,1)="+"
	end if
	junk=FNput_text%(midisqar_pointer&,transposition,text$)
	junk=FNobjc_draw(midisqar_pointer&,transposition,0,x,y,w,h)
	return

show_horizontal:
	text$=right$(str$(x_offset),2)+chr$(0)
	if x_offset>0 then
		mid$(text$,1,1)="+"
	end if
	junk=FNput_text%(midisqar_pointer&,horiz_interval,text$)
	junk=FNobjc_draw(midisqar_pointer&,horiz_interval,0,x,y,w,h)
	return

show_vertical:
	text$=right$(str$(y_offset),2)+chr$(0)
	if y_offset>0 then
		mid$(text$,1,1)="+"
	end if
	junk=FNput_text%(midisqar_pointer&,vert_interval,text$)
	junk=FNobjc_draw(midisqar_pointer&,vert_interval,0,x,y,w,h)
	return

select_mode:
	if peekw(FNobject_state&(midisqar_pointer&,poly_mode%)) and selected then
		for index=1 to 3
			m_channel(index)=m_channel(0)
		next
	else
		for index=1 to 3
			m_channel(index)=(m_channel(index-1)+1) mod 16
		next
	end if
	return

select_velocity:
	if peekw(FNobject_state&(midisqar_pointer&,velocity_a%)) and selected then
		inverse_velocity=0
	else
		inverse_velocity=1
	end if
	return

source_scale_data:
	DATA 1,3,5,6,8,10,12

units_data:
	DATA 1,2,3,4,6,8