* MIDI MASTER DRUMMER VERSION 2.5
* ASSEMBLY LANGUAGE ROUTINES FOR LINKING WITH DRUMMER2.BAS
* 9/18/93
* Copyright 1993 David Snow

	opt     lattice

global  	equr a5
button_state 	equr d7
xout		equr d6
yout		equr d5

_v_gtext	equ 8
_vst_height	equ 12
_vq_mouse	equ 124
_vs_clip	equ 129
_vq_key_s	equ 128
_replace_mode	equ 1
_xor_mode	equ 3
_write_mode	equ 32
_show_mouse	equ 122
_hide_mouse	equ 123
_play_pattern	equ 2
_stop_playback	equ 3
_play_phrase	equ 4
_play_song	equ 5
_pattern_audition	equ 6
_erase_patterns	equ 8
_xbtimer	equ 31
_left_shift	equ 2
_alt_key	equ 8

* The BASIC variables that we use
	XREF    _AES_ARRAYL
	XREF    _VDI_ARRAYL
	XREF    _VDI_CONTRLL
	XREF    _VDI_INTINL
	XREF    _VDI_PTSINL
	XREF    _VDI_INTOUTL
	XREF    _VDI_PTSOUTL

	XREF	_WIND_XI
	XREF	_WIND_YI
	XREF	_WORKSTATION_XI
	XREF	_WORKSTATION_YI
	XREF	_WORKSTATION_WI
	XREF	_WORKSTATION_HI

	XREF	_WORK_AREA_LEFTI
	XREF	_WORK_AREA_RIGHTI
	XREF	_WORK_AREA_TOPI
	XREF	_WORK_AREA_BOTTOMI

	XREF	_NORMAL_FONTI
	XREF	_GRID_FONTI

	XREF    _NORMAL_CELL_WIDTHI
	XREF    _NORMAL_CELL_HEIGHTI
	XREF    _MEDIUM_CELL_WIDTHI
	XREF    _MEDIUM_CELL_HEIGHTI
	XREF    _GRID_CELL_WIDTHI
	XREF    _GRID_CELL_HEIGHTI
	XREF    _SMALL_CELL_WIDTHI
	XREF    _SMALL_CELL_HEIGHTI

	XREF    _NAMES_LEFTI
	XREF    _NOTES_LEFTI
	XREF    _CHANNEL_LEFTI
	XREF    _ENABLE_LEFTI
	XREF    _GRID_LEFTI

	XREF    _NAMES_RIGHTI
	XREF    _NOTES_RIGHTII
	XREF    _CHANNEL_RIGHT
	XREF    _ENABLE_RIGHTI
	XREF    _GRID_RIGHTI

	XREF    _VELOCITY_BOX_LEFTI
	XREF    _VELOCITY_LEFTI
	XREF    _BUTTON_LEFTI
	XREF    _TEMPO_BOX_LEFTI
	XREF    _TEMPO_LEFTI

	XREF    _VELOCITY_BOX_RIGHTI
	XREF    _VELOCITY_RIGHTI
	XREF    _BUTTON_RIGHTI
	XREF    _TEMPO_BOX_RIGHTI
	XREF    _TEMPO_RIGHTI

	XREF    _VELOCITY_DATA_POSI
	XREF    _TEMPO_DATA_POSI

	XREF    _PATTERN_INFOLINEI
	XREF    _METER_INFOLINEI
	XREF    _GRID_TOPI
	XREF    _GRID_BOTTOMI

	XREF    _VELOCITY_TOPI
	XREF    _VELOCITY_ARROW_ROWI
	XREF    _VELOCITY_BOTTOMI

	XREF    _PHRASE_HEIGHTI
	XREF    _PHRASE_TOPI
	XREF    _PHRASE_BAR_BOTTOMI
	XREF    _PHRASE_TEXT_TOPI

	XREF    _PHRASE_BOX_HEIGHTI
	XREF    _PHRASE_BOTTOMI
	XREF    _PHRASE_RECTANGLE_HEIGHTI
	XREF    _PHRASE_BUTTONS_LEFTI
	XREF    _PHRASE_BUTTONS_RIGHTI
	XREF    _PHRASE_FIELDS_LEFTI
	XREF    _PHRASE_FIELDS_RIGHTI

	XREF    _MEASURE_NUMBER_TOPI
	XREF    _MEASURE_NUMBER_BOTTOMI

	XREF    _DRUM_RECTANGLE_HEIGHTI

	XREF    _FUNCTION_CODEI
	XREF    _PNI
	XREF    _PTI
	XREF    _PATTERN_ARRAY_POINTERL
	XREF    _STATUS_POINTERL
	XREF    _CHANNEL_POINTERL
	XREF    _PITCH_POINTERL
	XREF    _SPPI
	XREF    _NEXT_PHRASE_PARTI
	XREF    _END_FLAGI
	XREF    _TEMPO_ARROW_POSI
	XREF    _INTERRUPTS_PER_CLOCKI
	XREF    _BASE_VELOCITYI
	XREF    _TEMPO_CHANGE_FLAGI
	XREF    _VELOCITY_ARROW_POSI
	XREF    _BEATS_PER_MINUTEI
	XREF    _TEXT_ROWI
	XREF    _SCAN_CODEI
	XREF    _STEPS_PER_QUARTERL
	XREF    _STEPS_PER_CLICKI
	XREF    _METRONOME_FLAGI
	XREF    _ACCENT_VELOCITYI
	XREF    _ACCENT_CHAR_POINTERL
	XREF    _MIDI_CLOCK_FLAGI
	XREF    _SPMCI
	XREF    _MSFI
	XREF    _SPBEI

	XREF	_VELOCITY_INCREMENTI
	XREF	_MAXIMUM_BASE_VELOCITYI
	XREF	_VELOCITY_WIDTHI

* The routine that we are defining
	XDEF	mmd_library

mmd_library
	movem.l a3-a6,-(a7)		save registers

	cmpi.w #_play_pattern,_FUNCTION_CODEI(global)
	beq playback
	cmpi.w #_stop_playback,_FUNCTION_CODEI(global)
	beq stop_play
	cmpi.w #_play_phrase,_FUNCTION_CODEI(global)
	beq playback
	cmpi.w #_play_song,_FUNCTION_CODEI(global)
	beq playback
	cmpi.w #_pattern_audition,_FUNCTION_CODEI(global)
	beq playback
	cmpi.w #_erase_patterns,_FUNCTION_CODEI(global)
	beq erase_all
	bra exit_library

* * * * * * * * * * *
* ERASE ALL PATTERNS
* * * * * * * * * * *
erase_all
	move.l _PATTERN_ARRAY_POINTERL(global),a0
*					get pointer to pattern array
	add.l #76032,a0			calculate pointer to end of array
	move.l #19007,d0		set longword counter
e_loop
	clr.l -(a0)			predecrement pointer and clear
	dbra d0,e_loop
	bra exit_library	

* * * * * * * * 
* EXIT LIBRARY
* * * * * * * *
exit_library
	movem.l (a7)+,a3-a6		restore registers
	rts

* * * * * * * *
* STOP PLAYBACK
* * * * * * * *
stop_play
	bsr xor_mode
	pea end_auto(PC)		enable software end-of-interrupt mode
	move.w #38,-(a7)
	trap #14
	addq.l #6,a7

	clr.w d0			stop MFP timer A
	bsr mfptim

	TST.W _MSFI(global)		MIDI Start flag set?
	BEQ no_midi_stop
	move.w #$fc,d0			send MIDI stop
	bsr midi_out

no_midi_stop
	lea timer_A_flag(PC),a0		clear MFP timer A flag
	clr.w (a0)
	bra exit_library		return to calling program

* * * * * *
* PLAYBACK
* * * * * *
playback
	lea current_font(PC),a0
	clr.w (a0)
	bsr set_grid_font

	lea timer_A_flag(PC),a0		MFP timer A on?
	tst.w (a0)
	beq clear_counter		if not, then clear pulse counter

	lea pulse_flag(PC),a0		pulse flag set?
flag_loop
	tst.w (a0)
	beq flag_loop			if not, then loop

clear_counter
	lea pulses(PC),a0		reset total pulse counter
	clr.l (a0)

	lea interrupts_per_clock(PC),a0
	move.w _INTERRUPTS_PER_CLOCKI(global),(a0)

	lea steps_per_click(PC),a0
	move.w _STEPS_PER_CLICKI(global),(a0)

	lea spmc(PC),a0
	move.w _SPMCI(global),(a0)

	lea steps_per_quarter(PC),a0
	move.l _STEPS_PER_QUARTERL(global),(a0)

	lea spbe(PC),a0
	move.w _SPBEI(global),(a0)

	lea spp(PC),a0
	move.w _SPPI(global),(a0)

	lea steps_counter(PC),a0	set steps_per_beat counter
	move.l _STEPS_PER_QUARTERL(global),(a0)

	lea remainder(PC),a0		set remainder counter
	move.w _SPBEI(global),(a0)

	lea clocks_per_pulse(PC),a1	set clocks per pulse
	move.w _SPPI(global),(a1)

	tst.w (a0)			remainder>0?
	beq save_steps
	subq.w #1,(a0)			if so, decrement remainder
	addq.w #1,(a1)			increment steps per pulse

save_steps
	lea met_count(PC),a0		reset metronome step counter
	clr.w (a0)

	lea click_flag(PC),a0		set click flag...
	move.w #1,(a0)

	lea pulse_flag(PC),a0		set pulse flag...
	move.w #1,(a0)

	lea clocks(PC),a0		reset step counter...
	clr.w (a0)

	lea midi_clock_step(PC),a0	reset steps-per-MIDI-clock counter...
	move.w _SPMCI(global),(a0)

	lea timer_A_flag(PC),a0		MFP timer A on?
	tst.w (a0)
	bne start

* * * * * * * * * 
* INITIALIZATION
* * * * * * * * *
	move.w #1,(a0)			if not, then set MFP timer A flag...

	bsr vs_clip			set clipping rectangle...
	bsr replace_mode		set replace write-mode...

	lea count(PC),a0		set interrupt counter...
	move.w _INTERRUPTS_PER_CLOCKI(global),(a0)

	pea start_auto(PC)		set auto-end-of-interrupt mode...
	move.w #38,-(a7)
	trap #14
	addq.l #6,a7

	tst.w _MSFI(global)		MIDI START FLAG SET?
	beq skip_midi_start
	move.w #$fa,d0			send MIDI Start
	bsr midi_out

skip_midi_start
	move.w #4,d0			and start MFP timer A
	bsr mfptim

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* START OF MAIN PLAYBACK LOOP: check total pulse counter to see if
* current pattern has ended
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
start
	lea click_flag(PC),a0		metronome duration expired?
	tst.w (a0)
	beq check_total_pulses		if not, then check expired-pulse counter

	clr.w (a0)			clear click flag
	tst.w _METRONOME_FLAGI(global)	metronome flag set?
	beq check_total_pulses
	pea click_sound(PC)		if so, then click
	move.w #32,-(a7)
	trap #14
	addq.l #6,a7

check_total_pulses
	lea pulses(PC),a0		check total pulse counter (end of pattern?)
	move.l (a0),d0
	cmp.w _PTI(global),d0
	bhi exit_library

check_pulse
	lea pulse_flag(PC),a0		check pulse flag
	tst.w (a0)
	beq vq_mouse

	clr.w (a0)			reset pulse flag
	lea off_flag(PC),a0		set note-off flag
	move.w #1,(a0)

	move.l #15,d7			d7=drum loop counter
loop
	move.l d7,d4
	lsl.w #1,d4
	move.l _STATUS_POINTERL(global),a6
*					a6=pointer to drum status array
	cmpi.w #2,0(a6,d4.w)		drum status=muted?
	beq next_drum			if so, then skip to next drum

	move.w _PNI(global),d6
*					calculate pointer to current pulse
	mulu.w #768,d6			(calculate offset to current pattern)
	move.l d7,d5
	mulu.w #48,d5			(calculate offset to current drum part)
	add.l d5,d6
	lea pulses(PC),a0		(get offset to current pulse)
	add.l (a0),d6
	add.l _PATTERN_ARRAY_POINTERL(global),d6
*					(get pointer to pattern array)
	move.l d6,a6			a6=pointer to current pulse
	tst.b (a6)			velocity=0?
	beq next_drum			if so then skip to next drum

	move.l _CHANNEL_POINTERL(global),a4
*					a4=pointer to drum channel array
	move.w 0(a4,d4.w),d0		d0=drum channel
	add.w #144,d0			d0=MIDI note-on status byte
	bsr midi_out			output note-on status

	move.l _PITCH_POINTERL(global),a4
*					a4=pointer to drum pitch array
	move.w 0(a4,d4.w),d0		d0=MIDI drum pitch data
	bsr midi_out			output pitch data

	move.w _BASE_VELOCITYI(global),d0
*					d0=base velocity index
	clr.l d1			calculate velocity
	move.b (a6),d1
	subq.w #1,d1
	divu.w #3,d1
	mulu.w _VELOCITY_INCREMENTI(global),d1
	add.b d1,d0

	bsr midi_out			output velocity data

next_drum
	dbra d7,loop			check next drum

*	bra vq_mouse

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* MOUSE ROUTINES; check for left mouse button; mouse actions
* depend upon the screen position and playback mode
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

vq_mouse
	move.l _VDI_CONTRLL(global),a4
	move.w #_vq_mouse,(a4)
	clr.w 2(a4)			contrl(1)=0
	clr.w 6(a4)			contrl(3)=0
	bsr vdisys

	move.l _VDI_INTOUTL(global),a4
	move.w (a4),button_state	(d7=button_state)
	move.l _VDI_PTSOUTL(global),a4
	move.w (a4),xout		(d6=xout)
	move.w 2(a4),yout		(d5=yout)

	cmpi.w #_pattern_audition,_FUNCTION_CODEI(global)
	beq audition_pattern

	tst.w button_state		skip if no button
	beq delay

	cmpi.w #2,button_state		skip if both buttons
	bhi delay

* * * * * * * * * * * * * * * * * * * * * *
* THIS IS WHERE THE MONKEY BUSINESS BEGINS
* * * * * * * * * * * * * * * * * * * * * *

	move.l _VDI_CONTRLL(global),a4	get shift key status
	move.w #_vq_key_s,(a4)
	clr.w 2(a4)			contrl(1)=0
	clr.w 6(a4)			contrl(3)=0
	bsr vdisys

	move.l _VDI_INTOUTL(global),a4
	CMPI.W #_left_shift,(A4)	LEFT SHIFT?
	BNE TEST_ALT
	MOVE.W #2,button_state
	BRA CHECK_MODE

TEST_ALT
	CMPI.W #_alt_key,(A4)		ALTERNATE KEY?
	BNE CHECK_MODE
	MOVE.W #3,button_state

CHECK_MODE
	cmp.w #_play_phrase,_FUNCTION_CODEI(global)	seq playback mode?
	beq seq_song
	cmp.w #_play_song,_FUNCTION_CODEI(global)	song playback mode?
        beq seq_song

* * * * * * * * * * * * * * * * * * *
* I GUESS WE MUST BE IN PATTERN MODE
* * * * * * * * * * * * * * * * * * *

	cmp.w _GRID_TOPI(global),yout
	blt delay
	cmp.w _GRID_BOTTOMI(global),yout
	bge stop_pat

	cmp.w _ENABLE_LEFTI(global),xout
	bls delay
	cmp.w _ENABLE_RIGHTI(global),xout
	bhi enter_notes

* ENTER STATUS
*	drum_number=(yout-grid_top)\(grid_cell_height+1)
*	status_array_index=drum_number*2

	bsr hide_mouse

	clr.l d4
	move.w yout,d4
	sub.w _GRID_TOPI(global),d4
	move.w _GRID_CELL_HEIGHTI(global),d3
	addq.w #1,d3
	divu.w d3,d4				d4=drum number

	lea drum_number(PC),a0			save it for later
	move.w d4,(a0)
	lsl.w #1,d4				d4=status array index (bytes)

	move.l _STATUS_POINTERL(global),a0	a0=status array pointer
	move.w d7,0(a0,d4.w)			save status (mouse button code)

	lea stat_symbols(PC),a0			a0=symbol array pointer
	move.w d7,d0
	subq.w #1,d0
	lsl.w #1,d0				d0=symbol array offset
	move.w _ENABLE_LEFTI(global),d1
	add.w _NORMAL_CELL_WIDTHI(global),d1	d1=x coord of symbol
	bsr print_grid_symbol

	bra delay

* ENTER NOTES
enter_notes
	cmp.w _GRID_LEFTI(global),xout
	blt delay
	cmp.w _GRID_RIGHTI(global),xout
	bge delay

*	drum_number=(yout-grid_top)\(grid_cell_height+1)

	bsr hide_mouse

	clr.l d4
	move.w yout,d4
	sub.w _GRID_TOPI(global),d4
	move.w _GRID_CELL_HEIGHTI(global),d3
	addq.w #1,d3
	divu.w d3,d4
	andi.l #$ffff,d4			d4=drum number

	lea drum_number(PC),a0
	move.w d4,(a0)				save it for later

*	pulse&=(xout-grid_left)\(NORMAL_CELL_WIDTH+1)

	clr.l d3
	move.w xout,d3
	sub.w _GRID_LEFTI(global),d3
	move.w _NORMAL_CELL_WIDTHI(global),d2
	addq.w #1,d2
	divu.w d2,d3
	andi.l #$ffff,d3			d3=current pulse

	lea current_pulse(PC),a0
	move.w d3,(a0)				save it for later

	clr.l d2
	move.w _PNI(global),d2			d2=pat_number
	mulu.w #768,d2				pattern_array_pointer&=768*pat_number+48*drum+pulse%+pat_array%
	mulu.w #48,d4
	add.l d4,d2
	add.l d3,d2
	add.l _PATTERN_ARRAY_POINTERL(global),d2
	move.l d2,a0				a0=pattern_array_pointer&

* GET VELOCITY VALUE AND NOTE SYMBOL, AND PRINT IT
	CMPI.W #1,button_state
	BNE TRY_CODE_2
	MOVE.B #1,(A0)			WRITE VELOCITY 1 INTO PATTERN
	LEA NOTE_SYMBOLS(PC),A0		A0=SYMBOL ARRAY POINTER
	CLR.W D0			D0=ARRAY OFFSET
	BRA PRINT_NOTE

TRY_CODE_2
	CMPI.W #2,button_state
	BNE DO_CODE_3
	move.w _ACCENT_VELOCITYI(global),d0
	MOVE.B d0,(A0)			WRITE ACCENT VELOCITY INTO PATTERN
	MOVE.L _ACCENT_CHAR_POINTERL(global),A1
	LEA NOTE_SYMBOLS(PC),A0
	MOVE.B 0(A1),3(A0)		WRITE ACCENT CHAR INTO SYMBOL ARRAY
	MOVE.W #2,D0
	BRA PRINT_NOTE

DO_CODE_3
	CLR.B (A0)			ERASE VELOCITY VALUE IN PATTERN
	LEA NOTE_SYMBOLS(PC),A0
	MOVE.W #4,D0 
          
PRINT_NOTE
*	text_column&=(pulse&*(NORMAL_CELL_WIDTH+1))+grid_left+1

	clr.l d1
	move.w current_pulse(PC),d1
	move.w _NORMAL_CELL_WIDTHI(global),d2
	addq.w #1,d2
	mulu.w d2,d1
	add.w _GRID_LEFTI(global),d1
	addq.w #1,d1			d1=x coord of symbol

	bsr print_grid_symbol
	bra delay

* QUIT PLAYBACK IF 'PLAY' BUTTON CLICKED
stop_pat
	cmpi.w #_play_pattern,_FUNCTION_CODEI(global)
	bne set_tempo
	cmp.w _BUTTON_LEFTI(global),xout
	bls set_tempo
	cmp.w _BUTTON_RIGHTI(global),xout
	bhi set_tempo

	cmp.w _VELOCITY_TOPI(global),yout
	bls delay
	cmp.w _VELOCITY_BOTTOMI(global),yout
	bhi delay

	bsr notes_off
	move.w #1,_END_FLAGI(global)	set end flag
	bra exit_library		and return to calling program

set_tempo
	bsr set_velocity_or_tempo
	bra delay

* * * * * * * * * * * * * * * * * *
* PLAYBACK - SEQUENCE AND SONG MODE
* * * * * * * * * * * * * * * * * *
seq_song
	cmpi.w #1,button_state
	bne delay

	bsr set_velocity_or_tempo

	cmp.w _PHRASE_BUTTONS_LEFTI(global),xout
	blt delay
	cmp.w _PHRASE_BUTTONS_RIGHTI(global),xout
	bgt song_done

	cmp.w _PHRASE_TOPI(global),yout
	blt delay
	cmp.w _PHRASE_BOTTOMI(global),yout
	bgt delay

*	phrase_number=(yout-phrase_top)\phrase_height

	clr.l d0
	move.w yout,d0
	sub.w _PHRASE_TOPI(global),d0
	divu.w _PHRASE_HEIGHTI(global),d0	d0=selected phrase/part
	cmpi.w #15,d0				d0<=15
	bls legit_selection
	move.w #15,d0

legit_selection
	cmp.w _NEXT_PHRASE_PARTI(global),d0	old seq_part=new seq_part?
	bne old_part
	move.w #-1,_NEXT_PHRASE_PARTI(global)	if so, then clear old seq_part
old_part
	lea old_marker(PC),a0
	move.w _NEXT_PHRASE_PARTI(global),(a0)	save previous seq_part
	move.w d0,_NEXT_PHRASE_PARTI(global)	pass new seq_part back to calling program

*	y_coord=phrase_text_top+phrase_height*seq_part

	mulu.w _PHRASE_HEIGHTI(global),d0
	add.w _PHRASE_TEXT_TOPI(global),d0

	move.w #42,d1			d1=marker code ('*')
	bsr do_marker

	lea old_marker(PC),a0
	cmpi.w #-1,(a0)			erase old marker?
	beq delay
	move.w (a0),d0
	bsr erase_oldmark
	bra delay

song_done
	cmp.w _BUTTON_LEFTI(global),xout
	blt delay
	cmp.w _BUTTON_RIGHTI(global),xout
	bgt delay

	cmp.w _VELOCITY_TOPI(global),yout
	blt delay
	cmp.w _VELOCITY_BOTTOMI(global),yout
 	bgt delay

	bsr notes_off
	move.w #1,_END_FLAGI(global)
	bra exit_library		and return to calling program

* * * * * * * * * * * *
* PATTERN PULSE DELAY
* * * * * * * * * * * *
delay
	lea off_flag(PC),a0			note-off flag set?
	tst.w (a0)
	beq kbd_stat				if not, then skip note-off
	bsr notes_off

kbd_stat
	move.w #2,-(a7)				check keyboard status
	move.w #1,-(a7)				bconstat routine
	trap #13
	addq.l #4,a7
	tst d0					key pressed?
	beq incr_pulse_counter	

	move.w #2,-(a7)				if so, get scan code               bconin
	move.w #2,-(a7)
	trap #13
	addq.l #4,a7

	MOVE.L D0,D1
	SWAP D1					GET KEY SCAN CODE
	CMPI.W #$39,D1				SPACE BAR?
	BNE metronome_check
	move.w #1,_END_FLAGI(global)
	bra exit_library			if so, then exit

metronome_check
	cmpi.w #$14,D1				'T' KEY?
	bne tempo_down
	move.w _METRONOME_FLAGI(global),d0	if so, then get metronome flag...
	bchg #0,d0
	move.w d0,_METRONOME_FLAGI(global)	flip it...
	bra incr_pulse_counter			and continue

tempo_down
	CMPI.W #$33,D1				'<' KEY?
	BNE TEMPO_UP
	CMPI.W #20,_BEATS_PER_MINUTEI(global)	bpm<=20?
	BLS incr_pulse_counter			if so, skip it
	SUBQ.W #1,_BEATS_PER_MINUTEI(global)	else decrement bpm
	BSR PRINT_TEMPO
	BSR UPDATE_TEMPO			update interrupts
	BSR TEMPO_ARROW				move tempo arrow
	BRA incr_pulse_counter

tempo_up
	CMPI.W #$34,D1				'>' KEY?
	BNE VELOCITY_DOWN
	CMPI.W #244,_BEATS_PER_MINUTEI(global)	bpm>=244?
	BGE incr_pulse_counter			if so, skip it
	ADDQ.W #1,_BEATS_PER_MINUTEI(global)	else increment bpm
	BSR PRINT_TEMPO
	BSR UPDATE_TEMPO			update interrupts
	BSR TEMPO_ARROW				move tempo arrow
	BRA incr_pulse_counter

velocity_down
	CMPI.W #$1a,D1				'{' KEY?
	BNE velocity_UP
	CMPI.W #0,_BASE_VELOCITYI(global)	base_velocity<=0?
	BLS incr_pulse_counter			if so, skip it
	SUBQ.W #1,_BASE_VELOCITYI(global)	else decrement base_velocity
	BSR PRINT_velocity
	BSR velocity_ARROW			move velocity arrow
	BRA incr_pulse_counter

velocity_up
	CMPI.W #$1b,D1				'}' KEY?
	BNE pattern_up
	MOVE.W _MAXIMUM_BASE_VELOCITYI(global),d0
	CMP.W _BASE_VELOCITYI(global),D0	base_velocity>=maximum?
	BLE incr_pulse_counter			if so, skip it
	ADDQ.W #1,_BASE_VELOCITYI(global)	else increment base_velocity
	BSR PRINT_velocity
	BSR velocity_ARROW			move velocity arrow
	BRA incr_pulse_counter

* * * * *
pattern_up
	cmpi.w #_play_pattern,_FUNCTION_CODEI(global)
	bne pause_check
	cmpi.w #$48,d1				cursor up key?
	bne pattern_down

	move.w #3,_END_FLAGI(global)		set end flag
	move.w d1,d0				send scan code to BASIC
	BRA load_n_leave

pattern_down
	cmpi.w #_play_pattern,_FUNCTION_CODEI(global)
	bne pause_check
	cmpi.w #$50,d1				cursor down key?
	bne number_key_check

	move.w #3,_END_FLAGI(global)		set end flag
	move.w d1,d0
	BRA load_n_leave
* * * * *

number_key_check
	cmpi.w #_play_pattern,_FUNCTION_CODEI(global)
	bne pause_check
	cmpi.w #1,d1				number key?
	bls pause_check
	cmpi.w #10,d1
	bhi pause_check

	bsr new_accvel				if so, change accent velocity
	bra incr_pulse_counter			and continue

pause_check
	cmpi.w #27,d0				escape key?
	bne arrow_check

	clr.w d0				stop internal clock
	bsr mfptim
	pea end_auto(PC)			enable software end-of-interrupt mode
	move.w #38,-(a7)
	trap #14
	addq.l #6,a7

	TST.W _MSFI(global)		MIDI Start flag set?
	BEQ NO_PAUSE
	move.w #$fc,d0				if so, send MIDI stop
	bsr midi_out

no_pause
	movem.l d0-d7/a0-a6,-(a7)	save registers
	move.l _AES_ARRAYL(global),a0	get pointer to GEM arrays
*	move.l (a1),a0

	move.l 8(a0),a1			get gem_intin
	move.w #1,(a1)			default button #1

	move.l 16(a0),a1		get gem_addrin
	lea pause_alert(PC),a2
	move.l a2,(a1)			alert string

	move.l (a0),a1			get gem_control
	move.w #52,(a1)+		form_alert opcode
	move.w #1,(a1)+
	move.w #1,(a1)+
	move.w #1,(a1)+
	move.w #0,(a1)

	move.l a0,d1			aes call
	move.l #$c8,d0
	trap #2

	movem.l (a7)+,d0-d7/a0-a6	restore registers
	bsr vs_clip
	bsr replace_mode

	pea start_auto(PC)		set auto-end-of-interrupt mode...
	move.w #38,-(a7)
	trap #14
	addq.l #6,a7

	TST.W _MSFI(global)	MIDI Start flag set?
	BEQ no_midi_continue
	move.w #$fb,d0			send MIDI continue...
	bsr midi_out

no_midi_continue
	move.w #4,d0			restart MFP timer...
	bsr mfptim
	bra incr_pulse_counter		and continue

arrow_check
	cmpi.w #_play_pattern,_FUNCTION_CODEI(global)
	beq incr_pulse_counter		if pattern mode skip arrow check
	swap d0				get scan code
	cmpi.w #$48,d0			up arrow?
	beq load_n_leave

	cmpi.w #$50,d0			down arrow?
	beq load_n_leave

	cmpi.w #$4d,d0			right arrow?
	beq load_n_leave

	cmpi.w #$4b,d0			left arrow?
	beq load_n_leave

incr_pulse_counter
	lea off_flag(PC),a0		note-off flag set?
	tst.w (a0)
	beq start
	clr.w (a0)
	lea pulses(PC),a0		increment total pulse counter
	addq.l #1,(a0)
	bra start

* * * * * * * * * * * * * * * * * * * * * * * * * * * *
* SET VELOCITY OR TEMPO: PATTERN, PHRASE AND SONG MODES
* * * * * * * * * * * * * * * * * * * * * * * * * * * *

set_velocity_or_tempo
	cmp.w _VELOCITY_TOPI(global),yout
	blt quit_tempo
	cmp.w _VELOCITY_BOTTOMI(global),yout
	bgt quit_tempo

	cmp.w _VELOCITY_LEFTI(global),xout
	blt quit_tempo
	cmp.w _VELOCITY_RIGHTI(global),xout
	bgt tempo_scale
	cmpi.w #1,button_state		if left button then set velocity
	bne quit_tempo

*	base_velocity=((xout-velocity_left)*maximum_base_velocity)\velocity_width

	clr.l d1
	move.w xout,d1
	sub.w _VELOCITY_LEFTI(global),d1
	mulu.w _MAXIMUM_BASE_VELOCITYI(global),d1
	divu.w _VELOCITY_WIDTHI(global),d1
	move.w d1,_BASE_VELOCITYI(global)
	BSR PRINT_VELOCITY

	bsr hide_mouse			print velocity arrow
	move.w _VELOCITY_ARROW_POSI(global),d1	get old velocity arrow position
	move.w #32,d0			print space
	bsr print

*	VELOCITY_ARROW_POS=((BASE_VELOCITY*VELOCITY_WIDTH)\MAXIMUM_BASE_VELOCITY)+velocity_left-(normal_cell_width\2)
*	d0=symbol code
*	d1=x coord

	clr.l d1
	move.w _BASE_VELOCITYI(global),d1
	mulu.w _VELOCITY_WIDTHI(global),d1
	divu.w _MAXIMUM_BASE_VELOCITYI(global),d1
	add.w _VELOCITY_LEFTI(global),d1
	move.w _NORMAL_CELL_WIDTHI(global),d2
	lsr.w #1,d2
	sub.w d2,d1

	move.w d1,_VELOCITY_ARROW_POSI(global)		save new position
	move.w #2,d0					print arrow
	bsr print
	bsr show_mouse
	bra quit_tempo

tempo_scale
	cmp.w _TEMPO_LEFTI(global),xout
	blt quit_tempo
	cmp.w _TEMPO_RIGHTI(global),xout
	bhi quit_tempo
	cmpi.w #1,button_state
	bne quit_tempo

* CALCUALTE NEW BPM AND TEMPO CYCLE DURATION
*	beats_per_minute=xout-tempo_left+20

	MOVE.W xout,D1
	SUB.W _TEMPO_LEFTI(global),D1		d1=beats per minute
	addi.w #20,d1
	MOVE.W D1,_BEATS_PER_MINUTEI(global)	save it
	BSR PRINT_TEMPO				print tempo value
	BSR UPDATE_TEMPO			update interrupts

	bsr hide_mouse				print tempo arrow
	move.w _TEMPO_ARROW_POSI(global),d1	get old arrow position
	move.w #32,d0				print space
	bsr print

*	tempo_arrow_pos=xout-(normal_cell_width\2)

	clr.l d1
	move.w xout,d1				calculate new position
	move.w _NORMAL_CELL_WIDTHI(global),d0
	lsr.w #1,d0
	sub.w d0,d1
	move.w d1,_TEMPO_ARROW_POSI(global)	save new position
	move.w #2,d0				print arrow
	bsr print
	bsr show_mouse
quit_tempo
	rts

* * * * * * * * * * * * * * * * *
* SEND KEY SCANCODE BACK TO BASIC
* * * * * * * * * * * * * * * * *

load_n_leave
	move.w d0,_SCAN_CODEI(global)
	bra exit_library			exit

* * * * * *
* NOTES OFF
* * * * * *

notes_off
	move.l #15,d7				d7=drum loop_off counter
loop_off
	move.l d7,d4
	lsl.w #1,d4
	move.l _STATUS_POINTERL(global),a6	a6=pointer to drum status array
	cmpi.w #2,0(a6,d4.w)			drum status=muted?
	beq next_drum_off			if so, then skip to next drum

	clr.l d6
	move.w _PNI(global),d6			d6=pattern number
	mulu.w #768,d6				(calculate offset to current pattern)
	move.l d7,d5
	mulu.w #48,d5				(calculate offset to current drum part)
	add.l d5,d6
	lea pulses(PC),a0			(get offset to current pulse)
	add.l (a0),d6
	add.l _PATTERN_ARRAY_POINTERL(global),d6
*						(get pointer to pattern array)
	move.l d6,a6				a6=pointer to current pulse
	tst.b (a6)				velocity=0?
	beq next_drum_off			if so then skip to next drum

	move.l _CHANNEL_POINTERL(global),a4
*						a4=pointer to drum channel array
	move.w 0(a4,d4.w),d0			d0=drum channel
	add.w #144,d0				d0=MIDI note-on status byte
	bsr midi_out				output note-on status

	move.l _PITCH_POINTERL(global),a4
*						a4=pointer to drum pitch array
	move.w 0(a4,d4.w),d0			d0=MIDI drum pitch data
	bsr midi_out				output pitch data
	clr.w d0				d0=velocity 0 for note-off
	bsr midi_out				output velocity data
next_drum_off
	dbra d7,loop_off			check next drum
	rts

* * * * * * * * * * * * * * * * * * * * * * * * * * *
* AUDITION PATTERN (PLAYBACK ONLY: NO SCREEN GRAPICS)
* * * * * * * * * * * * * * * * * * * * * * * * * * *

audition_pattern
	cmpi.w #2,button_state		exit if RIGHT mouse button
	beq exit_library

	lea off_flag(PC),a0
	tst.w (a0)
	beq incr_pulse_counter
	bsr notes_off
	bra incr_pulse_counter

* * * * * * *
* SUBROUTINES
* * * * * * *

midi_out
	move.w d0,-(a7)               get data to ouput
	move.w #3,-(a7)               output device=MIDI interface
	move.w #3,-(a7)               execute bconout routine
	trap #13
	addq.l #6,a7
	rts

hide_mouse
	move.l _VDI_CONTRLL(global),a4
	move.w #_hide_mouse,(a4)
	clr.w 2(a4)			contrl(1)=0
	clr.w 6(a4)			contrl(3)=0
	bsr vdisys
	rts

replace_mode
	move.l _VDI_CONTRLL(global),a4
	move.w #_write_mode,(a4)
	clr.w 2(a4)			contrl(1)=0
	move.w #1,6(a4)			contrl(3)=1
	move.l _VDI_INTINL(global),a4
	move.w #_replace_mode,(a4)
	bsr vdisys
	rts

xor_mode
	move.l _VDI_CONTRLL(global),a4
	move.w #_write_mode,(a4)
	clr.w 2(a4)			contrl(1)=0
	move.w #1,6(a4)			contrl(3)=1
	move.l _VDI_INTINL(global),a4
	move.w #_xor_mode,(a4)
	bsr vdisys
	rts

vs_clip
*	vs_clip 1,wind_x,wind_y,workstation_x+workstation_w,workstation_y+workstation_h

	move.l _VDI_CONTRLL(global),a4
	move.w #_vs_clip,(a4)
	move.w #2,2(a4)				contrl(1)=2
	move.w #1,6(a4)				contrl(3)=1
	move.l _VDI_INTINL(global),a4
	move.w #1,(a4)				intin(0)=1 (clip flag)
	move.l _VDI_PTSINL(global),a4
	move.w _WIND_XI(global),(a4)		ptsin(0)=x1
	move.w _WIND_YI(global),2(a4)		ptsin(1)=y1
	move.w _WORKSTATION_XI(global),d0	ptsin(2)=x2
	add.w _WORKSTATION_WI(global),d0
	move.w d0,4(a4)
	move.w _WORKSTATION_YI(global),d0	ptsin(3)=y2
	add.w _WORKSTATION_HI(global),d0
	move.w d0,6(a4)
	bsr vdisys
	rts

set_grid_font
	movem.l d0/a0,-(a7)
	lea current_font(PC),a0		check current font
	move.w (a0),d0
	cmp.w _GRID_FONTI(global),d0
	beq grid_font_set
	move.w _GRID_FONTI(global),(a0)
	move.w _GRID_FONTI(global),d0	set to grid font
	bsr vst_height
grid_font_set
	movem.l (a7)+,d0/a0
	rts

set_normal_font
	movem.l d0/a0,-(a7)
	lea current_font(PC),a0			check current font
	move.w (a0),d0
	cmp.w _NORMAL_FONTI(global),d0
	beq normal_font_set
	move.w _NORMAL_FONTI(global),(a0)
	move.w _NORMAL_FONTI(global),d0		set to normal font
	bsr vst_height
normal_font_set
	movem.l (a7)+,d0/a0
	rts

vst_height
*	d0=character height

	move.l _VDI_CONTRLL(global),a4
	move.w #_vst_height,(a4)
	move.w #1,2(a4)				contrl(1)=1
	move.w #0,6(a4)				contrl(3)=0
	move.l _VDI_PTSINL(global),a4
	move.w #0,(a4)				ptsin(0)=0
	move.w d0,2(a4)				ptsin(1)=character height
	bsr vdisys
	rts

print_grid_symbol
*	a0=symbol array pointer
*	d0=symbol array index
*	d1=symbol x coord

	bsr set_grid_font

	move.l _VDI_CONTRLL(global),a4
	move.w #_v_gtext,(a4)
	move.w #1,2(a4)			contrl(1)=1
	move.w #1,6(a4)			contrl(3)=2
	move.l _VDI_INTINL(global),a4
	move.w 0(a0,d0.w),(a4)		intin(0)=symbol code
	clr.w 2(a4)			intin(1)=0
	move.l _VDI_PTSINL(global),a4
	move.w d1,(a4)			ptsin(0)=x coord

*	drum_row&=grid_top+1+(drum_number*(grid_cell_height+1))

	move.w _GRID_CELL_HEIGHTI(global),d0
	addq.w #1,d0
	lea drum_number(PC),a0
	mulu.w (a0),d0
	add.w _GRID_TOPI(global),d0
	addq.w #1,d0
	
	move.w d0,2(a4)			ptsin(1)=y coord
        bsr vdisys
        bsr show_mouse
        rts

show_mouse
	move.l _VDI_CONTRLL(global),a4
	move.w #_show_mouse,(a4)	contrl(0)=122
	clr.w 2(a4)			contrl(1)=0
	move.w #1,6(a4)			contrl(3)=1
	move.l _VDI_INTINL(global),a4
	clr.w (a4)			intin(0)=0
	bsr vdisys
	rts

print
*	d0=symbol code
*	d1=x coord

	bsr set_normal_font

	move.l _VDI_CONTRLL(global),a4
	move.w #_v_gtext,(a4)
	move.w #1,2(a4)               contrl(1)=1
	move.w #1,6(a4)               contrl(3)=2
	move.l _VDI_INTINL(global),a4
	move.w d0,(a4)                intin(0)=symbol code
	clr.w 2(a4)                   intin(1)=0
	move.l _VDI_PTSINL(global),a4
	move.w d1,(a4)					ptsin(0)=x coord
	move.w _VELOCITY_ARROW_ROWI(global),2(a4)	ptsin(1)=y coord
	bsr vdisys
	rts

do_marker
	bsr set_grid_font

	move.l _VDI_CONTRLL(global),a4
	move.w #_v_gtext,(a4)
	move.w #1,2(a4)               contrl(1)=1
	move.w #1,6(a4)               contrl(3)=2
	move.l _VDI_INTINL(global),a4
	move.w d1,(a4)                intin(0)=symbol code ('*' or ' ')
	clr.w 2(a4)
	move.l _VDI_PTSINL(global),a4

*	x coord=WORK_AREA_LEFT+NORMAL_CELL_WIDTH*18
	clr.l d2
	move.w _NORMAL_CELL_WIDTHI(global),d2
	mulu.w #18,d2
	add.w _WORK_AREA_LEFTI(global),d2

	move.w d2,(a4)			ptsin(0)=x coord
	move.w d0,2(a4)			ptsin(1)=y coord
	bsr vdisys
	rts

erase_oldmark
*	d0=phrase_text_top+(phrase_height*seq_part)

	mulu.w _PHRASE_HEIGHTI(global),d0
	add.w _PHRASE_TEXT_TOPI(global),d0

	move.w #32,d1                 d1=marker code (' ')
	bsr do_marker
	rts

vdisys
	move.l _VDI_ARRAYL(global),d1
	move.l #$73,d0
	trap #2
	rts

PRINT_VELOCITY
	BSR HIDE_MOUSE
	move.w _BASE_VELOCITYI(global),D1
	ANDI.L #$FFFF,D1
	LEA LINE_BUF(PC),A0
	MOVE.B #$20,2(A0)            default spaces
	MOVE.B #$20,1(A0)
dodec_2
	MOVE.L D1,D0
	DIVU.W #10,D0                get decimal value
	MOVE.W D0,D1                 save result
	SWAP D0                      form remainder
	ADDI.W #$30,D0               generate ASCII
	MOVE.B D0,(A0)+              place digit in buffer
	CMPI.W #0,D1                 done?
	BNE dodec_2
        
	bsr set_normal_font

	LEA LINE_BUF(PC),A0
	move.l _VDI_CONTRLL(global),a4
	move.w #_v_gtext,(a4)
	move.w #1,2(a4)               contrl(1)=1
	move.w #3,6(a4)               contrl(3)=3
	move.l _VDI_INTINL(global),a4
	CLR.W D0
	MOVE.B 2(A0),D0
	MOVE.W D0,(a4)                intin(0)=ASCII
	MOVE.B 1(A0),D0
	MOVE.W D0,2(a4)               intin(1)=ASCII
	MOVE.B (A0),D0
	MOVE.W D0,4(a4)               intin(2)=ASCII
	CLR.W 6(a4)                   intin(3)=0
	move.l _VDI_PTSINL(global),a4
	move.w _VELOCITY_DATA_POSI(global),(a4)		ptsin(0)=x coord
	move.w _VELOCITY_ARROW_ROWI(global),2(a4)	ptsin(1)=y coord
	bsr vdisys
	BSR SHOW_MOUSE
	RTS

PRINT_TEMPO
	BSR HIDE_MOUSE
	MOVE.W _BEATS_PER_MINUTEI(global),D1                D1=BPM
	ANDI.L #$FFFF,D1
	LEA LINE_BUF(PC),A0
	MOVE.B #$20,2(A0)            default space
dodec_1
	MOVE.L D1,D0
	DIVU.W #10,D0                get decimal value
	MOVE.W D0,D1                 save result
	SWAP D0                      form remainder
	ADDI.W #$30,D0               generate ASCII
	MOVE.B D0,(A0)+              place digit in buffer
	CMPI.W #0,D1                 done?
	BNE dodec_1

	bsr set_normal_font

	LEA LINE_BUF(PC),A0
	move.l _VDI_CONTRLL(global),a4
	move.w #_v_gtext,(a4)
	move.w #1,2(a4)               contrl(1)=1
	move.w #3,6(a4)               contrl(3)=3
	move.l _VDI_INTINL(global),a4
	CLR.W D0
	MOVE.B 2(A0),D0
	MOVE.W D0,(a4)                intin(0)=ASCII
	MOVE.B 1(A0),D0
	MOVE.W D0,2(a4)               intin(1)=ASCII
	MOVE.B (A0),D0
	MOVE.W D0,4(a4)               intin(2)=ASCII
	CLR.W 6(a4)                   intin(3)=0
	move.l _VDI_PTSINL(global),a4
	move.w _TEMPO_DATA_POSI(global),(a4)		ptsin(0)=x coord
	move.w _VELOCITY_ARROW_ROWI(global),2(a4)	ptsin(1)=y coord
	bsr vdisys
	BSR SHOW_MOUSE
	RTS

UPDATE_TEMPO
*	interrupts_per_clock=589824\(beats_per_minute*steps_per_quarter&)

	MOVE.W _BEATS_PER_MINUTEI(global),D1
	move.l _STEPS_PER_QUARTERL(global),d0
	MULU.W d0,D1
	MOVE.L #589824,D0
	DIVU.W D1,D0
	move.w d0,_INTERRUPTS_PER_CLOCKI(global)
	lea interrupts_per_clock(PC),a0
	move.w d0,(a0)
	RTS

velocity_arrow
	bsr hide_mouse
	move.w _VELOCITY_ARROW_POSI(global),d1	get old velocity arrow position
	move.w #32,d0                 		print space
	bsr print

*	VELOCITY_ARROW_POS=((BASE_VELOCITY*VELOCITY_WIDTH)\MAXIMUM_BASE_VELOCITY)+velocity_left-(normal_cell_width\2)

	clr.l d1
	move.w _BASE_VELOCITYI(global),d1
	mulu.w _VELOCITY_WIDTHI(global),d1
	divu.w _MAXIMUM_BASE_VELOCITYI(global),d1
	add.w _VELOCITY_LEFTI(global),d1
	move.w _NORMAL_CELL_WIDTHI(global),d2
	lsr.w #1,d2
	sub.w d2,d1
	move.w d1,_VELOCITY_ARROW_POSI(global)		save new position

	move.w #2,d0                  print arrow
	bsr print
	bsr show_mouse
	RTS

tempo_arrow
	bsr hide_mouse              print tempo arrow
	move.w _TEMPO_ARROW_POSI(global),d1	get old arrow position
	move.w #32,d0                 print space
	bsr print

*	tempo_arrow_pos=beats_per_minute-20+tempo_left-(normal_cell_width\2)

	MOVE.W _BEATS_PER_MINUTEI(global),D1
	subi.w #20,d1
	add.w _TEMPO_LEFTI(global),d1
	move.w _NORMAL_CELL_WIDTHI(global),d0
	lsr.w #1,d0
	sub.w d0,d1

	move.w d1,_TEMPO_ARROW_POSI(global)	save new position
	move.w #2,d0                  print arrow
	bsr print
	bsr show_mouse
	rts

* NEW ACCENT VELOCITY CHANGE ROUTINE
NEW_ACCVEL
	MOVE.L _ACCENT_CHAR_POINTERL(global),A0
	LEA ACCENT_SYMBOLS(PC),A1     A1=ACCENT SYMBOL ARRAY POINTER
	SUBQ.W #2,D1                  CONVERT SCAN CODE TO ARRAY INDEX
	MOVE.B 0(A1,D1.W),(A0)        UPDATE ACCENT_CHAR$

	ADDQ.W #1,D1                  CONVERT ARRAY INDEX TO ACCENT VELOCITY
	MULU.W #3,D1
	ADDQ.W #1,D1
	MOVE.W D1,_ACCENT_VELOCITYI(global)	UPDATE ACCENT_VELOCITY
	RTS

start_auto
	move.w sr,-(a7)			disable interrupts
	or.w #$700,sr 
	bclr.b #3,$fffa17		automatic end-of-interrupt mode
	move.w (a7)+,sr
	rts

end_auto
	move.w sr,-(a7)			disable interrupts
	or.w #$700,sr
	bset.b #3,$fffa17		stop auto end-of_int mode
	move.w (a7)+,sr
	rts

*	xbtimer interrupt rate=9.8304 kHz, or 589,824 interrupts per minute 

mfptim
	pea timer(PC)			interrupt routine vector
	move.w #5,-(a7)			count down from 5
	move.w d0,-(a7)			start/stop timer
	move.w #0,-(a7)			select timer a
	move.w #_xbtimer,-(a7)
	trap #14
	add.l #12,a7
	rts

* MASTER CLOCK INTERRUPT ROUTINE *
timer
	movem.l d0/a0-a1,-(a7)        save registers

	lea count(PC),a0
	addq.w #1,(a0)                increment interrupt counter

	lea interrupts_per_clock(PC),a1		interrupts=clock duration?
	move.w (a1),d0
	cmp.w (a0),d0
	bhi exit_master
	clr.w (a0)                    if so, then reset interrupt counter...

	lea met_count(PC),a0          increment metronome-STEP counter
	addq.w #1,(a0)
	lea steps_per_click(PC),a1
	move.w (a1),d0			get steps per click
	cmp.w (a0),d0                 metronome click?
	bhi inc_mclock
	clr.w (a0)                    if so, then reset met-STEP counter
	lea click_flag(PC),a0
	move.w #1,(a0)                and set click flag

inc_mclock
	lea spmc(PC),a1
	tst.w (a1)			MIDI CLOCK FLAG SET?
	BEQ NO_MIDICLK                IF NOT, SKIP IT                    
	LEA midi_clock_step(PC),A0
	SUBQ.W #1,(A0)                DECREMENT STEPS PER MIDI CLOCK COUNTER
	TST.W (A0)                    COUNTER EXPIRED?
	BNE NO_MIDICLK
	move.w (a1),(a0)		IF SO, RESET COUNTER

	lea $fffffc04,a1              MIDI ACIA control
test_midi
	move.b (a1),d0                get MIDI status
	btst #1,d0
	beq test_midi
	move.b #248,2(a1)             output MIDI clock

NO_MIDICLK
	lea clocks(PC),a0            increment step counter
	addq.w #1,(a0)

	lea steps_counter(PC),a0      decrement steps_per_beat counter
	subq.l #1,(a0)
	tst.l (a0)                    next beat?
	BNE NO_BEAT
	lea steps_per_quarter(PC),a1
	move.l (a1),(a0)		reset steps_per_beat counter

	lea spbe(PC),a0
	lea remainder(PC),a1		reset remainder counter
	move.w (a0),(a1)

NO_BEAT
	lea clocks_per_pulse(PC),a1         (a1)=steps per pulse
	move.w (a1),d0                d0=steps per pulse
	LEA CLOCKS(PC),A0
	cmp.w (a0),d0                 pulse expired?
	bhi exit_master

	clr.w (a0)                    if so, reset step counter...
	lea pulse_flag(PC),a0         set pulse_flag...
	move.w #1,(a0)

	lea spp(PC),a0
	lea clocks_per_pulse(PC),a1	UPDATE steps per pulse
	move.w (a0),(a1)

	lea remainder(PC),a0          remainder>0?
	tst.w (a0)
	beq exit_master
	subq.w #1,(a0)                decrement remainder
	addq.w #1,(a1)                increment steps per pulse
exit_master
	movem.l (a7)+,d0/a0-a1      restore registers
	rte

stat_symbols
	dc.b $00,$08,$00,$4d,$00,$53
note_symbols
	dc.b $00,$0b,$00,$3e,$00,$20
accent_symbols
	dc.b $31,$32,$33,$34,$35,$36,$37,$38,$3e
velocity
	dc.b $01,$1c,$00,$00
pause_alert
	dc.b '[1][ Pause ][ Continue ]',0,0
click_sound
	dc.b $00,$5a,$01,$00,$07,$3e,$08,$10,$0b,$00,$0c,$09,$0d,$00,$ff,$00
save_vector
	ds.l 1
midivec
	ds.l 1
tempo_val
	ds.l 1
pulses
	ds.l 1
line_buf
	ds.l 1
res_flag
	ds.w 1
timer_A_flag
	ds.w 1
count
	ds.w 1
clocks
	ds.w 1
clocks_per_pulse
	ds.w 1
pulse_flag
	ds.w 1
off_flag
	ds.w 1
met_count
	ds.w 1
click_flag
	ds.w 1
midi_clock_step
	ds.w 1
steps_counter
	ds.l 1
remainder
	ds.w 1
drum_number
	ds.w 1
current_pulse
	ds.w 1
current_font
	ds.w 1
interrupts_per_clock
	ds.w 1
steps_per_click
	ds.w 1
spmc
	ds.w 1
steps_per_quarter
	ds.l 1
spbe
	ds.w 1
spp
	ds.w 1
old_marker
	ds.w 1
	end