* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
*          MUSICBOX ASSEMBLY LANGUAGE SUBROUTINES
*                  
*                 COPYRIGHT 1989 DAVID SNOW
*
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* INITIALIZE 
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
          movea.l 6(a7),a6              RETRIEVE PARAMETER POINTER
          move.l (a6),d6               GET INDEX D6
          clr.w d7                      CLEAR INDEX COUNTER D7
          bsr INDEX                     BRANCH TO INDEXED ROUTINE:
          beq RECORD                    #1
          bsr INDEX
          beq PLAY                      #2
          bsr INDEX
          beq COPY                      #3
          bsr INDEX
          beq INVERT                    #4
          bsr INDEX
          beq REVERS                    #5
          bsr INDEX
          beq SHIFT                     #6
          bsr INDEX
          beq TRANSP                    #7
          bsr INDEX
          beq DIMAUG                    #8 (COMPRESS)
          bsr INDEX
          beq DIMAUG                    #9 (EXPAND)
          bsr INDEX
          beq RHYTHM                    #10
          bsr INDEX
          beq PITCH                     #11
          bra BASIC
INDEX     addq.w #1,d7
          cmp.w d7,d6
          rts
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* RECORD
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
RECORD    rts

*
*   START/STOP MFP TIMER
*
MFPTIM    pea TIMER(PC)                 GET INTERRUPT ROUTINE VECTOR
          move.w #10,-(a7)              COUNT DOWN FROM 10
          move.w d0,-(a7)               START/STOP TIMER
          move.w #0,-(a7)               SELECT TIMER A
          move.w #31,-(a7)              XBTIMER ROUTINE
          trap #14
          add.l #12,a7
          rts
*
*   TIMER INTERRUPT ROUTINE
*
TIMER     movem.l d0-d7/a0-a6,-(a7)     SAVE REGISTERS
          lea COUNT(PC),a5
          addq.w #1,(a5)                INCREMENT PULSE COUNTER
          movea.l #$FFFFFA0F,a3
          bclr #5,(a3)                  CLEAR INTERRUPT SERVICE BIT
          movem.l (a7)+,d0-d7/a0-a6     RESTORE REGISTERS
          rte

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
* PLAYBACK
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PLAY      lea SEQST(PC),a1
          move.l 4(a6),(a1)+           GET TRACK POINTER 'A'
          move.l 8(a6),(a1)+           GET TRACK POINTER 'B'
          move.l 12(a6),(a1)+           GET TRACK POINTER 'C'
          move.l 16(a6),(a1)            GET TRACK POINTER 'D'
          move.l 20(a6),d7              GET METRONOME FLAG D7
          move.l 24(a6),d5              GET TEMPO VALUE D5
          lea BASICHN(PC),a3
          move.l 28(a6),(a3)            GET MIDI BASIC CHANNEL
          lea TRAKPTR(PC),a6
* * * * * *
*  START  *
* * * * * *
          move.w #4,d0
          bsr MFPTIM                    START MFP TIMER
RESTRT    clr.w d3                      RESET TIME COUNTER D3
          lea SEQST(PC),a1
          move.l (a1)+,(a6)
          move.l (a1)+,4(a6)
          move.l (a1)+,8(a6)
          move.l (a1),12(a6)
CLOCK     tst d7
          beq RSET                      IF FLAG=0 THEN NO METRONOME
          pea SOUND(PC)
          move.w #32,-(a7)
          trap #14
          addq.l #6,a7
RSET      move.w #24,d2                 RESET PULSE COUNTER D2
BEAT      lea COUNT(PC),a2
          clr.w (a2)                    RESET CYCLE COUNTER A2
          move.w #248,d0                OUTPUT MIDI TIMING CLOCK
          bsr MIDOUT
          addq.w #1,d3                  INCREMENT TIME COUNTER
          subq.w #1,d2                  DECREMENT PULSE COUNTER D2
          tst d2
          beq CLOCK
RECYCL    cmp.w (a2),d5                 HAS CYCLE COUNTER EXPIRED?
          bls BEAT
          movem.l d1-d2/a2,-(a7)        SAVE REGISTERS FOR BIOS CALL
          move.w #2,-(a7)               CHECK FOR KEY PRESS (EXIT PLAYBACK)
          move.w #1,-(a7)
          trap #13
          addq.l #4,a7
          movem.l (a7)+,d1-d2/a2        RETRIEVE REGISTERS
          tst d0
          bne RETURN

          clr.w d4
TESTEND   move.l 0(a6,d4.w),a5          TEST FOR END OF SEQUENCE:
          move.w (a5),d0                ALL TIMESTAMPS<=COUNTER?
          cmp.w d3,d0
          bhi PLATRAK                   IF NOT, SKIP TEST
          cmp.b #253,2(a5)              ALL END-OF-TRACK MARKERS?
          bne PLATRAK                   IF NOT, SKIP TEST
          addq.w #4,d4
          cmpi.w #12,d4
          bls TESTEND
          bra RESTRT                    RESTART SEQUENCE
 
PLATRAK   clr.w d6
          lea BASICHN(PC),a4
          move.l (a4),d4                GET MIDI BASIC CHANNEL
          lea ALLOFF(PC),a4             NOTE-OFF ARRAY POINTER
TESTRAK   move.l 0(a6,d6.w),a5
          cmp.b #253,2(a5)
          beq NEXTRAK
          move.w (a5),d0                TIMESTAMP =TIME COUNTER VALUE?
          cmp.w d3,d0                
          bhi NEXTRAK
          addq.l #2,a5
          move.w d4,d0                  OUPUT NOTE-ON COMMAND
          bsr MIDOUT
          move.b (a5),(a4)              SAVE PITCH VALUE FOR NOTE-OFF
          move.b (a5)+,d0               OUTPUT PITCH DATA
          bsr MIDOUT
          move.b (a5)+,d0               OUTPUT VELOCITY DATA
          bsr MIDOUT
          move.l a5,0(a6,d6.w)
NEXTRAK   addq.w #1,d4
          addq.l #1,a4
          addq.w #4,d6
          cmpi.w #12,d6
          bls TESTRAK

          bra RECYCL
* * * * * * * * * * *
*  RETURN TO BASIC  *
* * * * * * * * * * *
RETURN    move.w #2,-(a7)               EMPTY KEYBOARD BUFFER
          move.w #2,-(a7)
          trap #13
          addq.l #4,a7
          move.w #0,d0
          bsr MFPTIM                    STOP TIMER
          bsr SILENT                    ALL NOTES OFF
          rts
*
*  MIDI DATA OUPUT SUBROUTINE
*
MIDOUT    movem.l d1-d2/a2,-(a7)        SAVE REGISTERS FOR BIOS CALL
          move.w d0,-(a7)               OUTPUT MIDI DATA
          move.w #3,-(a7)
          move.w #3,-(a7)
          trap #13
          addq.l #6,a7
          movem.l (a7)+,d1-d2/a2        RETRIEVE REGISTERS
          rts
*
* ALL NOTES OFF SUBROUTINE
*
SILENT    lea BASICHN(PC),a4
          move.l (a4),d7
          lea ALLOFF(PC),a4
          move.w #3,d6
OFF       move.w d7,d0
          bsr MIDOUT
          addq.w #1,d7
          move.b (a4)+,d0
          bsr MIDOUT
          clr.w d0
          bsr MIDOUT
          dbra d6,OFF
          rts 
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* COPY
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
COPY      move.l 4(a6),a5              GET SOURCE-TRACK POINTER
          move.l 8(a6),a4              GET DESTINATION-TRACK POINTER
DOIT1     move.l (a5)+,(a4)+
          cmpi.b #253,-2(a5)
          beq BASIC
          bra DOIT1
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* TRANSPOSE
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
TRANSP    move.l 4(a6),a5              GET TRACK POINTER
          move.l 8(a6),d7              GET TRANSPOSITION VALUE
DOIT2     cmpi.b #253,2(a5)
          beq BASIC
          add.b d7,2(a5)
          addq.l #4,a5
          bra DOIT2
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* INVERT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
INVERT    move.l 4(a6),a5              GET TRACK POINTER
DOIT3     cmpi.b #253,2(a5)
          beq BASIC
          move.b #120,d5
          sub.b 2(a5),d5
          move.b d5,2(a5)
          addq.l #4,a5
          bra DOIT3
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* SHIFT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
SHIFT     move.l 4(a6),a5              GET TRACK POINTER
          move.l 8(a6),d7              GET SHIFT VALUE
          move.w (a5),d5                CANCEL SHIFT IF START<1
          add.w d7,d5
          cmpi.w #0,d5
          bls BASIC
DOIT4     add.w d7,(a5)
          cmpi.b #253,2(a5)
          beq BASIC
          addq.l #4,a5
          bra DOIT4
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* REVERSE
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
REVERS    move.l 4(a6),a5              GET TRACK POINTER
          move.l 8(a6),a4
          clr.w d5                      RESET WORD COUNTER D5
BUFR      move.l (a5)+,(a4)+            COPY EVENT (A5) TO BUFFER (A4)
          addq.w #1,d5                  INCREMENT EVENT COUNTER D5
          cmpi.b #253,-2(a5)
          bne BUFR
          sub.l #8,a4                   SET BUFFER POINTER A4 TO LAST NOTE
          move.w (a4),d4                SET TIMESTAMP INDEX D4
          addq.w #1,d4
          sub.w #2,d5                   ADJUST EVENT COUNTER D5
          move.l 4(a6),a5              SET SEQUENCE POINTER A5 TO FIRST NOTE
DOIT5     move.w d4,d3                  CALCULATE NEW TIMESTAMP
          sub.w (a4),d3
          move.w d3,(a5)
          move.b 2(a4),2(a5)            SAVE PITCH DATA
          cmpi.b #0,3(a4)
          beq ON
          move.b #0,3(a4)               TURN NOTE-OFF TO NOTE-ON
          bra SWITCH
ON        move.b #64,3(a4)              TURN NOTE-ON TO NOTE-OFF
SWITCH    move.b 3(a4),3(a5)
          addq.l #4,a5
          sub.l #4,a4
          dbf d5,DOIT5 
          bra BASIC
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
* COMPRESS/EXPAND
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
DIMAUG    move.l 4(a6),a5              GET TRACK POINTER
          move.l 8(a6),d7
HOP       cmpi.w #1,(a5)                IF TIMESTAMP=1 THEN LOOK
          bne DOIT6                     FOR TIMESTAMP>1   
          addq.l #4,a5
          bra HOP
DOIT6     clr.l d5
          move.w (a5),d5
          cmpi.w #8,d6
          beq DIMIN
          mulu.w d7,d5                  AUGMENTATION
JUMP      move.w d5,(a5)
          cmpi.b #253,2(a5)
          beq BASIC
          addq.l #4,a5
          bra DOIT6
DIMIN     divu d7,d5                    DIMINUTION
          bra JUMP
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* GENERATE PITCH SEQUENCE
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
PITCH     move.l 4(a6),a5              GET TRACK POINTER A5
          move.l 8(a6),a4              GET BUFFER POINTER A4
          move.l 12(a6),d6              GET NUMBER OF NOTES-IN-BUFFER D6
          movea.l #5400,a6
          adda.l a5,a6                  GET END-OF-TRACK POINTER A6
DOLOOP    cmpa.l a5,a6                  END OF TRACK?
          bls BASIC
          addq.l #2,a5                  SKIP TIMESTAMP
          cmpi.b #253,(a5)              END OF SEQUENCE?
          beq BASIC
          move.w #17,-(a7)              GENERATE RANDOM NUMBER D0
          trap #14
          addq.l #2,a7
          andi.l #$000F,d0              LIMIT TO 4 BITS
TRYIT     cmp.w d6,d0                   D0<=D6?
          bls KEEPIT
          lsr.w #1,d0                   IF NOT, SHIFT D0 RIGHT
          bra TRYIT
KEEPIT    movea.l a4,a3
          adda.w d0,a3
          move.b (a3),(a5)              GET PITCH FROM BUFFER (NOTE ON)
          addq.l #4,a5
          move.b (a3),(a5)              GET PITCH FROM BUFFER (NOTE OFF)
          addq.l #2,a5                  JUMP TO NEXT TIMESTAMP
          bra DOLOOP
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* GENERATE RHYTHMIC SEQUENCE
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
RHYTHM    move.l 4(a6),a5              GET TRACK POINTER A5
          move.l 8(a6),a4              GET RHYTHM-BUFFER POINTER A4
          move.l #5280,a6
          adda.l a5,a6                  GET END-OF-TRACK POINTER A6
          move.l #1,d7                  RESET TIMESTAMP COUNTER D7
MAKEIT    cmpa.l a5,a6                  END OF TRACK?
          bls TRMSEQ
          cmpi.l #65535,d6              MAXIMUM TIMESTAMP VALUE?
          bhi QUITIT 
          move.w #17,-(a7)              GENERATE RANDOM NUMBER D0
          trap #14
          addq.l #2,a7
          andi.l #7,d0                  LIMIT TO 3 BITS (D0<=7)
          mulu.w #20,d0                 CALCULATE PATTERN ADDRESS OFFSET
          movea.l d0,a3
          adda.l a4,a3                  GET RHYTHM POINTER A3
UPDATE    move.w d7,d6                  GET NOTE-ON TIMESTAMP D6
          add.w (a3),d6                 UPDATE NOTE-ON TIMESTAMP
          cmpi.w #0,2(a3)               END OF RHYTHM PATTERN?
          bne STAMP
          add.w (a3),d7                 UPDATE TIMESTAMP COUNTER
          bra MAKEIT                    NEXT PATTERN
STAMP     move.w d6,(a5)+               LOAD NOTE-ON TIMESTAMP TO TRACK
          move.b #0,(a5)+               CLEAR PITCH DATA
          move.w #17,-(a7)              GENERATE RANDOM NUMBER D0
          trap #14
          addq.l #2,a7
          andi.l #63,d0                 CALCULATE VELOCITY VALUE (96-127)
          ori.l #64,d0
          move.b d0,(a5)+               LOAD VELOCITY TO TRACK (NOTE ON)
          addq.l #2,a3                  POINT TO NEXT RHYTHMIC ELEMENT
          move.w d6,d5                  GET NOTE-OFF TIMESTAMP D5
          add.w (a3),d5                 UPDATE NOTE-OFF TIMESTAMP
          move.w d5,(a5)+               LOAD NOTE-OFF TIMESTAMP TO TRACK
          move.b #0,(a5)+               CLEAR PITCH DATA
          move.b #0,(a5)+               LOAD VELOCITY (NOTE OFF)
          addq.l #2,a3                  POINT TO NEXT RHYTHMIC ELEMENT
          bra update
QUITIT    move.w #65535,d6
TRMSEQ    move.w d6,(a5)+
          move.b #253,(a5)              APPEND END-OF-TRACK MARKER
          bra BASIC
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
* RETURN TO BASIC
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
BASIC     rts
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
SOUND     dc.w $005A,$0100,$073E,$0810,$0B00,$0C09,$0D00,$FF00
STVAL     ds.l 1
SEQST     ds.l 4
TRAKPTR   ds.l 4
BASICHN   ds.l 1
ALLOFF    ds.b 4
COUNT     ds.w 1
          end






