'MIDI NOTE-TO-PHRASE GENERATOR
'HiSoft BASIC
'12/26/93

DEFINT a-z
LIBRARY "gemdos","gemaes"

GOSUB initialize
DO
	tempo=0
	DO
		INPUT " Tempo (20-240 bpm): ",tempo
	LOOP UNTIL tempo>=20 AND tempo<=240

	pulses_per_beat=0
	DO
		INPUT " Subdivision of beat (1-12): ",pulses_per_beat
	LOOP UNTIL pulses_per_beat >=1 AND pulses_per_beat<=12	
	
	GOSUB play_phrase
	CLS
	alert$="[2][Play again?][Yes|No]"
	IF FNform_alert(2,alert$)=2 THEN
		EXIT LOOP
	END IF
LOOP
SYSTEM


play_phrase:
	FOR phrase=0 TO 63
		phrase_index(phrase)=-1
	NEXT
	phrase_selector=0

	steps_per_pulse=steps_per_beat/pulses_per_beat
	step_duration!=60/(TEMPO*steps_per_beat)
	pulse_duration!=steps_per_pulse*step_duration!

	CLS
	PRINT " Ready for MIDI input... (press <ESC> to quit)"
	WHILE INP(-3)<>0
		junk=INP(3)
	WEND

	smf_buffer&=VARPTR(smf_buffer(0))
	POKEL smf_buffer&+18,0				'dummy track length
	smf_index&=22
	GOSUB set_tempo

	delta_time&=0-steps_per_pulse
	next_pulse!=TIMER

	DO
		IF TIMER>=next_pulse! THEN
			next_pulse!=TIMER+pulse_duration!
			delta_time&=delta_time&+steps_per_pulse
			FOR phrase=0 TO 63
				IF phrase_index(phrase)>=0 THEN
					DECR phrase_rhythms(phrase,phrase_index(phrase))
					IF phrase_rhythms(phrase,phrase_index(phrase))=0 THEN
						GOSUB continue_phrase
					END IF
				END IF
			NEXT
		END IF

		IF INP(-3)<>0 THEN
			midi_byte=INP(3) AND &hff
			IF midi_byte>=144 AND midi_byte<=159 THEN
				status_flag=1
				status=midi_byte
				global_channel=status AND &hf

				pitch=INP(3) AND &hff
				velocity=INP(3) AND &hff
				GOSUB start_phrase
			ELSEIF midi_byte<128 THEN
				IF status_flag THEN
					pitch=midi_byte
					velocity=INP(3) AND &hff
					GOSUB start_phrase
				END IF
			ELSE
				status_flag=0
			END IF
		END IF
		IF INP(-2)<>0 THEN
			IF INP(2)=27 THEN
				EXIT LOOP
			END IF
		END IF
	LOOP
	FOR phrase=0 TO 63
		FOR index=0 TO 7
			note_off global_channel,phrase_pitches(phrase,index)
		NEXT
	NEXT
	MOUSE 0
	GOSUB save_midifile
	RETURN

start_phrase:
	note_on global_channel,pitch,velocity

	phrase_index(phrase_selector)=0
	FOR index=0 TO 7
		phrase_pitches(phrase_selector,index)=pitch-12+INT(RND*24)
		phrase_velocities(phrase_selector,index)=velocity-8+INT(RND*16)
		base_duration=((128-velocity)/8)+1
		phrase_rhythms(phrase_selector,index)=INT(RND*base_duration)+1
	NEXT
	phrase_pitches(phrase_selector,0)=pitch
	phrase_velocities(phrase_selector,0)=velocity

	INCR phrase_selector
	IF phrase_selector>63 THEN
		phrase_selector=0
	END IF
	RETURN

continue_phrase:
	note_off global_channel,phrase_pitches(phrase,phrase_index(phrase))

	INCR phrase_index(phrase)
	IF phrase_index(phrase)>7 THEN
		phrase_index(phrase)=-1
	ELSE
		note_on global_channel,phrase_pitches(phrase,phrase_index(phrase)),phrase_velocities(phrase,phrase_index(phrase))
	END IF

	RETURN

initialize:
	MOUSE 2
	RANDOMIZE(0)

	steps_per_beat=96

	DIM phrase_pitches(63,7)
	DIM phrase_rhythms(63,7)
	DIM phrase_velocities(63,7)
	DIM phrase_index(63)

	drive_no=FNdgetdrv%
	getdir$=space$(128)
	getdir&=sadd(getdir$)
	dgetpath getdir&,0
	index=0: while peekb(getdir&+index)<>32: index=index+1: wend
	path$=chr$(drive_no+65)+":"+left$(getdir$,index-1)
	midifile_path$=path$+"\*.MID"

	buffer_size&=fre(0)-&h20000
	dim smf_buffer(buffer_size&\2)
	smf_buffer&=varptr(smf_buffer(0))

	'SET UP SMF HEADER CHUNK
	pokeb smf_buffer&,asc("M")
	pokeb smf_buffer&+1,asc("T")
	pokeb smf_buffer&+2,asc("h")
	pokeb smf_buffer&+3,asc("d")
	pokel smf_buffer&+4,6		'length of header
	pokew smf_buffer&+8,0		'SMF format 0
	pokew smf_buffer&+10,1		'1 track
	POKEW smf_buffer&+12,steps_per_beat

	'SET UP TRACK CHUNK
	pokeb smf_buffer&+14,asc("M")
	pokeb smf_buffer&+15,asc("T")
	pokeb smf_buffer&+16,asc("r")
	pokeb smf_buffer&+17,asc("k")

	MOUSE -1
	WINDOW OPEN 0,"Phrase generator",PEEKW(SYSTAB+58),PEEKW(SYSTAB+60),PEEKW(SYSTAB+62),PEEKW(SYSTAB+64),1

	RETURN

set_tempo:
	smf_tempo&=(60/tempo)*1000000
	smf_tempo_ptr&=varptr(smf_tempo&)

	pokeb smf_buffer&+smf_index&,&h00	'delta time
	incr smf_index&
	pokeb smf_buffer&+smf_index&,&hff	'meta event
	incr smf_index&
	pokeb smf_buffer&+smf_index&,&h51
	incr smf_index&
	pokeb smf_buffer&+smf_index&,&h03
	incr smf_index&
	pokeb smf_buffer&+smf_index&,peekb(smf_tempo_ptr&+1)
	incr smf_index&
	pokeb smf_buffer&+smf_index&,peekb(smf_tempo_ptr&+2)
	incr smf_index&
	pokeb smf_buffer&+smf_index&,peekb(smf_tempo_ptr&+3)
	incr smf_index&
	RETURN

'DELTA TIME VARIABLE-LENGTH QUANTITY CONVERSION
delta_conversion:
	vlq_buffer&=0
	vlq_pointer&=varptr(vlq_buffer&)
	pokeb vlq_pointer&+3,delta_time& and &h7f
	pointer_offset&=2
	delta_time&=delta_time&\&h80
	while delta_time&<>0
		pokeb vlq_pointer&+pointer_offset&,delta_time& or &h80
		decr pointer_offset&
		delta_time&=delta_time&\&h80
	wend
	incr pointer_offset&
	while pointer_offset&<4
		pokeb smf_buffer&+smf_index&,peekb(vlq_pointer&+pointer_offset&)
		incr smf_index&
		incr pointer_offset&
	wend
	RETURN

save_midifile:
	beep

	'APPEND END-OF-TRACK META-EVENT
	delta_time&=0
	gosub delta_conversion

	pokeb smf_buffer&+smf_index&,&hff	'meta-event
	incr smf_index&
	pokeb smf_buffer&+smf_index&,&h2f
	incr smf_index&
	pokeb smf_buffer&+smf_index&,&h00

	pokel smf_buffer&+18,smf_index&-22	'update sequence length

	save_midi:
	file_name$=""
	fsel_input midifile_path$,file_name$,ok
	if ok then
		if file_name$="" then
			alert$="[3][Are you sure you want|to discard MIDI file?][Yes|No]"
			if FNform_alert(1,alert$)=2 then
				goto save_midi
			end if
		else
			graf_mouse 2,0
			index=len(midifile_path$)
			while index>0 and mid$(midifile_path$,index,1)<>"\"
				decr index
			wend
			exit_file$=left$(midifile_path$,index)+file_name$
			BSAVE exit_file$,SMF_BUFFER&,SMF_INDEX&
			graf_mouse 0,0
		end if
	else
		alert$="[3][Are you sure you want|to discard MIDI file?][Yes|No]"
		if FNform_alert(1,alert$)=2 then
			goto save_midi
		end if
	end if
	RETURN

SUB note_off(global_channel,pitch)
SHARED smf_buffer&,smf_index&
	out 3,128+global_channel
	out 3,pitch
	out 3,64

	GOSUB delta_conversion
	POKEB smf_buffer&+smf_index&,128+global_channel
	INCR smf_index&
	POKEB smf_buffer&+smf_index&,pitch
	INCR smf_index&
	POKEB smf_buffer&+smf_index&,64
	INCR smf_index&
END SUB

SUB note_on(global_channel,pitch,velocity)
SHARED smf_buffer&,smf_index&
	out 3,144+global_channel
	out 3,pitch
	out 3,velocity

	GOSUB delta_conversion

	POKEB smf_buffer&+smf_index&,144+global_channel
	INCR smf_index&
	POKEB smf_buffer&+smf_index&,pitch
	INCR smf_index&
	POKEB smf_buffer&+smf_index&,velocity
	INCR smf_index&
END SUB

